pcl::SurfelSmoothing< PointT, PointNT > Class Template Reference

`#include <pcl/surface/surfel_smoothing.h>`

Inheritance diagram for pcl::SurfelSmoothing< PointT, PointNT >:

## Public Types

typedef boost::shared_ptr< SurfelSmoothing< PointT, PointNT > > | Ptr
typedef boost::shared_ptr< const SurfelSmoothing< PointT, PointNT > > | ConstPtr
typedef pcl::PointCloud< PointT > | PointCloudIn
typedef pcl::PointCloud< PointT >::Ptr | PointCloudInPtr
typedef pcl::PointCloud< PointNT > | NormalCloud
typedef pcl::PointCloud< PointNT >::Ptr | NormalCloudPtr
typedef pcl::search::Search< PointT > | CloudKdTree
typedef pcl::search::Search< PointT >::Ptr | CloudKdTreePtr
Public Types inherited from pcl::PCLBase< PointT >
typedef pcl::PointCloud< PointT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| SurfelSmoothing (float a_scale=0.01)
void | setInputNormals (NormalCloudPtr &a_normals)
void | setSearchMethod (const CloudKdTreePtr &a_tree)
bool | initCompute ()
float | smoothCloudIteration (PointCloudInPtr &output_positions, NormalCloudPtr &output_normals)
void | computeSmoothedCloud (PointCloudInPtr &output_positions, NormalCloudPtr &output_normals)
void | smoothPoint (size_t &point_index, PointT &output_point, PointNT &output_normal)
void | extractSalientFeaturesBetweenScales (PointCloudInPtr &cloud2, NormalCloudPtr &cloud2_normals, boost::shared_ptr< std::vector< int > > &output_features)
Public Member Functions inherited from pcl::PCLBase< PointT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Additional Inherited Members

Protected Member Functions inherited from pcl::PCLBase< PointT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...
Protected Attributes inherited from pcl::PCLBase< PointT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointT, typename PointNT>
class pcl::SurfelSmoothing< PointT, PointNT >

Definition at line 47 of file surfel_smoothing.h.

## Member Typedef Documentation

template<typename PointT , typename PointNT >

typedef pcl::search::Search<PointT> pcl::SurfelSmoothing< PointT, PointNT >::CloudKdTree

Definition at line 60 of file surfel_smoothing.h.

template<typename PointT , typename PointNT >

typedef pcl::search::Search<PointT>::Ptr pcl::SurfelSmoothing< PointT, PointNT >::CloudKdTreePtr

Definition at line 61 of file surfel_smoothing.h.

template<typename PointT , typename PointNT >

typedef boost::shared_ptr<const SurfelSmoothing<PointT, PointNT> > pcl::SurfelSmoothing< PointT, PointNT >::ConstPtr

Definition at line 54 of file surfel_smoothing.h.

template<typename PointT , typename PointNT >

typedef pcl::PointCloud<PointNT> pcl::SurfelSmoothing< PointT, PointNT >::NormalCloud

Definition at line 58 of file surfel_smoothing.h.

template<typename PointT , typename PointNT >

typedef pcl::PointCloud<PointNT>::Ptr pcl::SurfelSmoothing< PointT, PointNT >::NormalCloudPtr

Definition at line 59 of file surfel_smoothing.h.

template<typename PointT , typename PointNT >

typedef pcl::PointCloud<PointT> pcl::SurfelSmoothing< PointT, PointNT >::PointCloudIn

Definition at line 56 of file surfel_smoothing.h.

template<typename PointT , typename PointNT >

typedef pcl::PointCloud<PointT>::Ptr pcl::SurfelSmoothing< PointT, PointNT >::PointCloudInPtr

Definition at line 57 of file surfel_smoothing.h.

template<typename PointT , typename PointNT >

typedef boost::shared_ptr<SurfelSmoothing<PointT, PointNT> > pcl::SurfelSmoothing< PointT, PointNT >::Ptr

Definition at line 53 of file surfel_smoothing.h.

## Constructor & Destructor Documentation

template<typename PointT , typename PointNT >

pcl::SurfelSmoothing< PointT, PointNT >::SurfelSmoothing | ( | float | a_scale = `0.01` | ) |

inline

Definition at line 63 of file surfel_smoothing.h.

## Member Function Documentation

template<typename PointT , typename PointNT >

void pcl::SurfelSmoothing< PointT, PointNT >::computeSmoothedCloud | ( | PointCloudInPtr & | output_positions,
|  | NormalCloudPtr & | output_normals
| ) |  |

Definition at line 244 of file surfel_smoothing.hpp.

Referenced by pcl::SurfelSmoothing< PointT, PointNT >::setSearchMethod().

template<typename PointT , typename PointNT >

void pcl::SurfelSmoothing< PointT, PointNT >::extractSalientFeaturesBetweenScales | ( | PointCloudInPtr & | cloud2,
|  | NormalCloudPtr & | cloud2_normals,
|  | boost::shared_ptr< std::vector< int > > & | output_features
| ) |  |

Definition at line 273 of file surfel_smoothing.hpp.

Referenced by pcl::SurfelSmoothing< PointT, PointNT >::setSearchMethod().

template<typename PointT , typename PointNT >

bool pcl::SurfelSmoothing< PointT, PointNT >::initCompute | ( |  | ) |

Definition at line 46 of file surfel_smoothing.hpp.

Referenced by pcl::SurfelSmoothing< PointT, PointNT >::setSearchMethod().

template<typename PointT , typename PointNT >

void pcl::SurfelSmoothing< PointT, PointNT >::setInputNormals | ( | NormalCloudPtr & | a_normals | ) |

inline

Definition at line 75 of file surfel_smoothing.h.

template<typename PointT , typename PointNT >

void pcl::SurfelSmoothing< PointT, PointNT >::setSearchMethod | ( | const CloudKdTreePtr & | a_tree | ) |

inline

Definition at line 78 of file surfel_smoothing.h.

References pcl::SurfelSmoothing< PointT, PointNT >::computeSmoothedCloud(), pcl::SurfelSmoothing< PointT, PointNT >::extractSalientFeaturesBetweenScales(), pcl::SurfelSmoothing< PointT, PointNT >::initCompute(), pcl::SurfelSmoothing< PointT, PointNT >::smoothCloudIteration(), and pcl::SurfelSmoothing< PointT, PointNT >::smoothPoint().

template<typename PointT , typename PointNT >

float pcl::SurfelSmoothing< PointT, PointNT >::smoothCloudIteration | ( | PointCloudInPtr & | output_positions,
|  | NormalCloudPtr & | output_normals
| ) |  |

Definition at line 82 of file surfel_smoothing.hpp.

References pcl::squaredEuclideanDistance().

Referenced by pcl::SurfelSmoothing< PointT, PointNT >::setSearchMethod().

template<typename PointT , typename PointNT >

void pcl::SurfelSmoothing< PointT, PointNT >::smoothPoint | ( | size_t & | point_index,
|  | PointT & | output_point,
|  | PointNT & | output_normal
| ) |  |

Definition at line 158 of file surfel_smoothing.hpp.

Referenced by pcl::SurfelSmoothing< PointT, PointNT >::setSearchMethod().

The documentation for this class was generated from the following files:

- /build/pcl-6_P28C/pcl-1.7.2/surface/include/pcl/surface/surfel_smoothing.h
- /build/pcl-6_P28C/pcl-1.7.2/surface/include/pcl/surface/impl/surfel_smoothing.hpp